// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_introspection_msgs:msg/ParamInfo.idl
// generated code does not contain a copyright notice
#include "marti_introspection_msgs/msg/detail/param_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `name`
// Member `resolved_name`
// Member `description`
// Member `group`
// Member `default_string`
#include "rosidl_runtime_c/string_functions.h"

bool
marti_introspection_msgs__msg__ParamInfo__init(marti_introspection_msgs__msg__ParamInfo * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    marti_introspection_msgs__msg__ParamInfo__fini(msg);
    return false;
  }
  // resolved_name
  if (!rosidl_runtime_c__String__init(&msg->resolved_name)) {
    marti_introspection_msgs__msg__ParamInfo__fini(msg);
    return false;
  }
  // description
  if (!rosidl_runtime_c__String__init(&msg->description)) {
    marti_introspection_msgs__msg__ParamInfo__fini(msg);
    return false;
  }
  // group
  if (!rosidl_runtime_c__String__init(&msg->group)) {
    marti_introspection_msgs__msg__ParamInfo__fini(msg);
    return false;
  }
  // type
  // dynamic
  // default_int
  // default_float
  // default_double
  // default_string
  if (!rosidl_runtime_c__String__init(&msg->default_string)) {
    marti_introspection_msgs__msg__ParamInfo__fini(msg);
    return false;
  }
  // default_bool
  // max_value
  // min_value
  return true;
}

void
marti_introspection_msgs__msg__ParamInfo__fini(marti_introspection_msgs__msg__ParamInfo * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // resolved_name
  rosidl_runtime_c__String__fini(&msg->resolved_name);
  // description
  rosidl_runtime_c__String__fini(&msg->description);
  // group
  rosidl_runtime_c__String__fini(&msg->group);
  // type
  // dynamic
  // default_int
  // default_float
  // default_double
  // default_string
  rosidl_runtime_c__String__fini(&msg->default_string);
  // default_bool
  // max_value
  // min_value
}

marti_introspection_msgs__msg__ParamInfo *
marti_introspection_msgs__msg__ParamInfo__create()
{
  marti_introspection_msgs__msg__ParamInfo * msg = (marti_introspection_msgs__msg__ParamInfo *)malloc(sizeof(marti_introspection_msgs__msg__ParamInfo));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_introspection_msgs__msg__ParamInfo));
  bool success = marti_introspection_msgs__msg__ParamInfo__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_introspection_msgs__msg__ParamInfo__destroy(marti_introspection_msgs__msg__ParamInfo * msg)
{
  if (msg) {
    marti_introspection_msgs__msg__ParamInfo__fini(msg);
  }
  free(msg);
}


bool
marti_introspection_msgs__msg__ParamInfo__Sequence__init(marti_introspection_msgs__msg__ParamInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_introspection_msgs__msg__ParamInfo * data = NULL;
  if (size) {
    data = (marti_introspection_msgs__msg__ParamInfo *)calloc(size, sizeof(marti_introspection_msgs__msg__ParamInfo));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_introspection_msgs__msg__ParamInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_introspection_msgs__msg__ParamInfo__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_introspection_msgs__msg__ParamInfo__Sequence__fini(marti_introspection_msgs__msg__ParamInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_introspection_msgs__msg__ParamInfo__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_introspection_msgs__msg__ParamInfo__Sequence *
marti_introspection_msgs__msg__ParamInfo__Sequence__create(size_t size)
{
  marti_introspection_msgs__msg__ParamInfo__Sequence * array = (marti_introspection_msgs__msg__ParamInfo__Sequence *)malloc(sizeof(marti_introspection_msgs__msg__ParamInfo__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_introspection_msgs__msg__ParamInfo__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_introspection_msgs__msg__ParamInfo__Sequence__destroy(marti_introspection_msgs__msg__ParamInfo__Sequence * array)
{
  if (array) {
    marti_introspection_msgs__msg__ParamInfo__Sequence__fini(array);
  }
  free(array);
}
